unit ufunction;
{$mode objFPC}
//{$goto on}

interface

{$if defined (Windows) or defined (Unix)}
uses
   SysUtils;

{$if defined (TrackID)}
   function Umlaut_Kill(Value: String): String;
{$endif}

   function TtoS(T: TDateTime): String;

{$endif}

{$ifdef cpuavr}
function bool(value: Byte): boolean;
function BtC(Value: boolean): char;

function CharToUint(Value1, Value2, Value3: uint8): uint8;

procedure delay(value: int32);
procedure delay_1u_8;
procedure delay_500n_8;

var _Data                    : array [0..7] of char;
{$endif}

// Proceduren und Funktionen für alle Plattformen und CPU-Typen

{$if defined (Unix)}
function _IDE_Load(const Dir, IDE: UnicodeString; Const _File: Array of UnicodeString; Flags:TExecuteFlags=[]): String;
function IDE_Load(const Dir, IDE: UnicodeString; Const _File: Array of UnicodeString; Flags:TExecuteFlags=[]): integer;

{$endif}

{$ifdef cpuavr}
procedure DezToBin(aint, bits:integer);
{$endif}

implementation

{$if defined (Windows) or defined (Unix)}
{$ifdef Unix}

function _IDE_Load(const Dir, IDE: UnicodeString; Const _File: Array of UnicodeString; Flags:TExecuteFlags=[]): String;
begin
  result                     := IntToStr(ExecuteProcess(Dir+IDE, _File, []));
end;

function IDE_Load(const Dir, IDE: UnicodeString; Const _File: Array of UnicodeString; Flags:TExecuteFlags=[]): integer;
begin
  result                     := ExecuteProcess(Dir+IDE, _File, []);
end;

{$endif}

{$if defined (TrackID)}
function Umlaut_Kill(Value: String): String;
const
  Umlaut                     : array[0..6] of String = ('Ä','Ö','Ü','ß', ' - ', '           ', '_ ');
  UmlautErsatz               : array[0..6] of String = ('AE','OE','UE','ss', #10#13, '', ', ');
Var
  f:Integer;
begin
  Result:='';
  For f:= 0 to High(Umlaut) do
  Value                      := StringReplace(Value, Umlaut[f],UmlautErsatz[f], [rfReplaceAll]);
  Result                     := Value;
end;
{$endif}

function TtoS(T: TDateTime): String;
var
  h, m, s, ms: Word;
begin
  DecodeTime(T, h, m, s, ms);
  if h > 0 then
    Result                 := FormatDateTime('hh:nn:ss',T)
  else
    Result                 := FormatDateTime('nn:ss',T);
end;

{$endif}

{$ifdef CPUAVR}

function CharToUint(Value1, Value2, Value3: uint8): uint8;
var temp: uint8;
begin
  // EINER
  case Value3 of
       0: begin temp         := 0; end;
       1: begin temp         := 1; end;
       2: begin temp         := 2; end;
       3: begin temp         := 3; end;
       4: begin temp         := 4; end;
       5: begin temp         := 5; end;
       6: begin temp         := 6; end;
       7: begin temp         := 7; end;
       8: begin temp         := 8; end;
       9: begin temp         := 9; end;
       end;
  // ZEHNER
  case Value2 of
       0: begin temp         := temp + 0; end;
       1: begin temp         := temp + 10; end;
       2: begin temp         := temp + 20; end;
       3: begin temp         := temp + 30; end;
       4: begin temp         := temp + 40; end;
       5: begin temp         := temp + 50; end;
       6: begin temp         := temp + 60; end;
       7: begin temp         := temp + 70; end;
       8: begin temp         := temp + 80; end;
       9: begin temp         := temp + 90; end;
       end;
  // HUNDERT
  case Value1 of
       0: begin temp         := temp + 0; end;
       1: begin temp         := temp + 100; end;
       2: begin temp         := temp + 200; end;
       3: begin temp         := temp + 300; end;
       4: begin temp         := temp + 400; end;
       5: begin temp         := temp + 500; end;
       6: begin temp         := temp + 600; end;
       7: begin temp         := temp + 700; end;
       8: begin temp         := temp + 800; end;
       9: begin temp         := temp + 900; end;
       end;

end;

// Change the bytes (0 | 1) to boolean values (False = 0 | True = 1)
function bool(value: Byte): boolean;
begin
  if value = 0 then result := False;
  if value = 1 then result := True;
end;

function BtC(Value: boolean): char;
begin
  if not value then result := '0';
  if     value then result := '1';
end;

procedure DezToBin(aint, bits:integer);
var
  B:integer;
  puffer:integer;

begin
puffer := aint;
for B:= bits downto 0 do
    begin
    if puffer mod 2 = 0 then
       begin
       Puffer:= puffer div 2;
       _Data[b]:= '0';
       end
    else
        begin
        puffer:= Puffer div 2;
        _Data[b]:= '1';
        end;
    end;
end;

// Zeitfunctionen
procedure delay(value: int32);
var
  i: int32;
begin
  for i := 1 to value do begin
    asm nop end;
    end;
end;

// Kurzes Delay (1µs bei 8 MHz)
procedure delay_1u_8;
label
  loop;
begin
  asm
    ldi r16, 60
    loop:
      dec r16
      brne loop
    end['r16'];
  end;

// Kurzes Delay (0.5µs bei 8 MHz)
procedure delay_500n_8;
label
  loop;
begin
  asm
    ldi r16, 30
    loop:
      dec r16
      brne loop
    end['r16'];
  end;

{$endif}

end.

